/* CouchDB (public) structures
 *
 * CouchDB C API (libcouchdb) - Copyright (c) 2006 Dirk Schalge
 *
 * Thanks to Damien Katz and all other involved developers for this great
 * database!
 *
 * See doc/LICENSE for licensing details.
 */

#ifndef CDB_HEADER_STRUCT
#define CDB_HEADER_STRUCT

typedef struct couch_ Couch;
typedef struct couch_doc_ CouchDocument;
typedef struct couch_doc_field_ CouchDocumentField;
typedef struct couch_doc_field_content_ CouchDocumentFieldContent;
typedef struct couch_result_ CouchResult;

struct couch_
{
	char *server;
	char *db;

	CouchResult *result;
	CURL *curl;
	char *xml;
};

struct couch_doc_
{
	char *docid;	/* the real docid of couchdb => a new doc will have -1 here */
	char *revid;	/* revision of the document - needed for updates */
	List *content;
};

struct couch_doc_field_
{
	char *name;
	List *values;
};

struct couch_doc_field_content_
{
	int type;	/* 0 = string, 1 = int */
	char *value;
};


struct couch_result_
{
	int code;	/* HTTP response code (404, 200, ...) */
			/* FIXME: do we really need the http code? */
	int type;	/* 0 = error, 1 = success */
	char *error;	/* error message */
	char *docid;	/* affected document */
	char *revid;	/* updated revision id */
};

struct MemoryStruct
{
	char *memory;
	size_t size;
};

#endif
