/* CouchDB miscellaneous functions and platform dependend
 * workarounds
 *
 * CouchDB C API (libcouchdb) - Copyright (c) 2006 Dirk Schalge
 *
 * Thanks to Damien Katz and all other involved developers for this great
 * database!
 *
 * See doc/LICENSE for licensing details.
 */

#include "libcouchdb.h"

#ifndef _GNU_SOURCE
char *strndup ( const char *s, size_t n )
{
	char *buf = NULL;

	if ( !s || strlen(s) < 1 )
	{
		errno = EINVAL;
		return NULL;
	}

	buf = calloc ( n, sizeof(char) );

	if ( buf )
		strncpy ( buf, s, n );

	return buf;
}
#endif

void *couch_realloc ( void *ptr, size_t size )
{
	if ( ptr )
		return realloc ( ptr, size );
	else
		return malloc ( size );
}
