<?php
include 'Library/Shrink.php';
include 'Library/CouchDb/Couch.php';

$couch = new Couch('localhost', 'bugshrink');

if(!$couch->running()) {
	die("Cannot connect to CouchDb");
}

if(!$couch->db_exists()) {
	echo 'creating schema';
	include 'createSchema.php';
}

include 'header.php';


if($id = var_register('id')) {
	//show bug
	if($bug_details = $couch->get($id)) {
		$bug_details->set('Body', $bug_details->get('Body'));
	} else {
		echo "Cannot find Bug with id: $id";
	}
} 

$edit = false;
$action = var_register('action');

switch($action) {
	case 'edit':
		$edit = true;
		//fall thru
	case 'add':
		include 'newBug.php';
		if(!empty($revision)) {
			shrink_show_bug_details($bug_details);
		}
	break;
	
	case 'delete':
		if(!$couch->delete($id)) {
			echo 'There was an Error deleting the Bug';
		}
		$id = false;
	break;
	
	case 'Open': // fall thru
		$State = 'Open';
	case 'Close':

		if(!isset($State)) { $State = 'Closed'; }
		shrink_toggle_status($id, $State);
		$bug_details->set('State', $State);
		// fall thru
	default:
	if($id) {
		shrink_show_bug_details($bug_details);
	}
	break;
} 

if(('add' != $action) && !$id) {
	?><div id="add"><a href="?action=add">Add a Bug</a></div><hr><?php
}

if(!$id && ('add' != $action)) {
	shrink_show_bugs();
}

include 'footer.php';