@ECHO OFF

REM 
REM This launches Antlr to process the fabric grammar file (grammar.g) and generate
REM FabricLexer.cpp. FabricParser.cpp, etc..
REM

IF NOT defined ANTLRJAR SET ANTLRJAR=../bintools/antlr.jar

REM First nuke the old generated code. This is necessary because when Antlr
REM runs it doesn't update the modified time of the generated files if no changes
REM are applied to them.
REM This causes the build to unnecessarily rerun antlr because it never
REM knows the generated files are up to date.

del /Q GeneratedCode\*.*
call java -classpath "%ANTLRJAR%;%CLASSPATH%" antlr.Tool -o GeneratedCode Grammar.g 2>&1 | ..\bintools\unix_util_rewrite.exe

exit %errorlevel%
@ECHO ON