/* CouchDB table-handling functions
 *
 * CouchDB C API (libcouchdb) - Copyright (c) 2006 Dirk Schalge
 *
 * Thanks to Damien Katz and all other involved developers for this great
 * database!
 *
 * See doc/LICENSE for licensing details.
 */

#include "libcouchdb.h"
#include "xml.h"
#include "curl.h" 

List *couch_table_compute ( Couch *c, char *name )
{
	List *l = NULL;

	if ( !c || !name )
	{
		errno = EINVAL;
		return NULL;
	}

	/* send GET to server */
	couch_curl_doc_get ( c, name );

	l = couch_xml_parse_table ( c->xml );

	if ( !l )
	{
		/* parse error */
		couch_xml_parse_response ( c );
		return NULL;
	}

	return l;
}
