@REM setup the VisualStudio environment vars
call "%VS71COMNTOOLS%\vsvars32.bat"

@REM build the project
devenv /build Release CouchDb.sln
@if not %errorlevel%==0 exit /B %errorlevel%

@REM build the kit directory
mkdir win32_kit\CouchDb\

@REM Compile the Erlang couch builder utility
"%ERLANG_ROOT%\bin\erlc" build_couch.erl
@if not %errorlevel%==0 exit /B %errorlevel%

@REM Make the app and rel files
"%ERLANG_ROOT%\bin\erl" -noshell -run build_couch  compile_all
@if not %errorlevel%==0 exit /B %errorlevel%

"%ERLANG_ROOT%\bin\erl" -noshell -run build_couch  output_full_libs "win32_kit/CouchDb/"
@if not %errorlevel%==0 exit /B %errorlevel%


xcopy dist\common win32_kit\CouchDb\ /S /E /D /Y
xcopy dist\win32 win32_kit\CouchDb\ /S /E /D /Y
xcopy couch.boot win32_kit\CouchDb\ /D /Y
xcopy "%ERTS_ROOT%\bin\erl.exe" win32_kit\CouchDb\ /D /Y
xcopy "%ERTS_ROOT%\bin\beam.dll" win32_kit\CouchDb\ /D /Y
xcopy "%ERTS_ROOT%\bin\erlexec.dll" win32_kit\CouchDb\ /D /Y
xcopy "%ERTS_ROOT%\bin\inet_gethost.exe" win32_kit\CouchDb\ /D /Y
xcopy FabricServer\Release\FabricServer.exe win32_kit\CouchDb\ /D /Y
xcopy CouchDb\Release\couch_erl_driver.dll win32_kit\CouchDb\ /D /Y
xcopy "%ICU_ROOT%\bin\icudt??.dll" win32_kit\CouchDb\ /D /Y
xcopy "%ICU_ROOT%\bin\icuin??.dll" win32_kit\CouchDb\ /D /Y
xcopy "%ICU_ROOT%\bin\icuuc??.dll" win32_kit\CouchDb\ /D /Y
xcopy "%SystemRoot%\system32\msvcr71.dll" win32_kit\CouchDb\ /D /Y